︠09de7e22-e67d-4915-8607-c331f6551cb5︠
# Given say {"a": 3, "b": 10, "c": 7, "d": 19} and [1,5,15] return {0: ["a"], 1: ["b", "c"], 2: ["d"]}
def find_read_to(read_dates, message_dates):
        read_indexes_to_user_ids = {}
        for user_id in read_dates:
                for i, date in enumerate(message_dates):
                        last_index = i + 1 == len(message_dates)
                        next_index = -1 if last_index else i + 1
                        if last_index or (read_dates[user_id] >= date and read_dates[user_id] < message_dates[next_index]):
                                if i in read_indexes_to_user_ids:
                                        read_indexes_to_user_ids[i].append(user_id)
                                else:
                                        read_indexes_to_user_ids[i] = [user_id]
                                break
        return read_indexes_to_user_ids

find_read_to({"a": 3, "b": 10, "c": 7, "d": 19}, [1,5,15])
︡b3d0faf0-0051-4c2a-846f-3c67f03ab7e2︡{"stdout":"{0: ['a'], 1: ['c', 'b'], 2: ['d']}\n"}︡{"done":true}︡
︠9df09e74-331c-4866-b53f-93aec21aa7aa︠
import bisect
def find_read_to(read_dates, message_dates):
        read_indexes_to_user_ids = {}
        user_ids, read_dates = zip(*read_dates.items())
        def find_between(read_date):
                answer = bisect.bisect_left(message_dates, read_date)
                answer -= 1
                if answer == -1:
                        return None
                return answer
        indexes_for_read_up_to = map(find_between, read_dates)
        for i, index_for_read_up_to in enumerate(indexes_for_read_up_to):
                user_id = user_ids[i]
                if index_for_read_up_to in read_indexes_to_user_ids:
                        read_indexes_to_user_ids[index_for_read_up_to].append(user_id)
                else:
                        read_indexes_to_user_ids[index_for_read_up_to] = [user_id]
        return read_indexes_to_user_ids

find_read_to({"a": 3, "b": 10, "c": 7, "d": 19}, [1,5,15])
︡2aa54588-6d1a-4a49-adae-1f601a847b7c︡{"stdout":"{0: ['a'], 1: ['c', 'b'], 2: ['d']}\n"}︡{"done":true}︡
︠ed4fe1fd-b880-4a56-9750-b474b83793f1is︠
%hide
def coffee(code):
    with open('coffeecode.coffee', 'w') as f:
        f.write(code)
    (child_stdin, child_stdout, child_stderr) = os.popen3('coffee coffeecode.coffee')
    sys.stdout.write(child_stdout.read())
    sys.stderr.write('\n'+child_stderr.read())

︡3704c896-ad51-4a04-a795-cc65f97f4e6f︡{"hide":"input"}︡{"done":true}︡
︠c4c08aaf-0612-4146-901d-20912e788166s︠
%coffee
underscore = require('underscore')
Array::bisect = (val) ->
    idx = undefined
    if @length == 0
        return 0
    idx = 0
    while idx < @length
        if val < @[idx]
            return idx
        idx++
    idx

find_read_tos = (read_dates, message_dates) ->
    read_indexes_to_user_ids = {}
    [user_ids, read_dates] = [Object.keys(read_dates), underscore.values(read_dates)]
    find_between = (read_date) ->
        answer = message_dates.bisect(read_date)
        answer -= 1
        if answer == -1
            return null
        return answer
    indexes_for_read_up_to = (find_between(date) for date in read_dates)
    for index_for_read_up_to, i in indexes_for_read_up_to
        user_id = user_ids[i]
        if index_for_read_up_to is null
            continue
        if String(index_for_read_up_to) in Object.keys(read_indexes_to_user_ids)
            read_indexes_to_user_ids[index_for_read_up_to].push(user_id)
        else
            read_indexes_to_user_ids[index_for_read_up_to] = [user_id]
    return read_indexes_to_user_ids

console.log(find_read_tos({"a": 3, "b": 10, "c": 7, "d": 19}, [1,5,15]))
︡08786d3d-991d-46cd-81be-b9437243fa55︡{"stdout":"{ '0': [ 'a' ], '1': [ 'b', 'c' ], '2': [ 'd' ] }\n"}︡{"stderr":"\n"}︡{"done":true}︡
︠f9f94955-3734-4991-9c0c-1a48f059cfa7s︠
%coffee
array_bisect = (arr, val) ->
    idx = undefined
    if arr.length == 0
        return 0
    idx = 0
    while idx < arr.length
        if val < arr[idx]
            return idx
        idx++
    idx
console.log(array_bisect([0,3,5,15,30,90], 11))
︡3912dbfc-4f58-47d7-bbc9-6fb432895c27︡{"stdout":"3\n"}︡{"stderr":"\n"}︡{"done":true}︡
︠0c610aee-2f99-4e6a-ba5f-5619d33c7d73︠

︡dcfafb2f-2e31-4c84-a79c-5ca893682e05︡
︠d4c572d1-ab84-4c88-8f40-a0c334ce2a84s︠
coffee??
︡3eda6b8d-f29a-4721-afdd-8fe25cbbe3af︡{"code":{"filename":null,"lineno":-1,"mode":"python","source":"   File: /projects/d8eac431-3b55-40d3-89ee-fcada259f1ad\nUnable to read source code (source code not available)"}}︡{"done":true}︡
︠7c52a660-ec9f-43d7-aede-6616a92765ebs︠
%coffee
find_smaller_number = (arr, val) ->
    idx = undefined
    if arr.length == 0
        return -1
    idx = 0
    while idx < arr.length
        if val < arr[idx]
            return idx - 1
        idx++
    idx - 1
console.log(find_smaller_number([], 9))
︡7eafb5e5-b790-4d50-9188-d42277849356︡{"stdout":"-1\n"}︡{"stderr":"\n"}︡{"done":true}︡
︠8171f1bd-ff2c-465d-8c1f-b2a23ada8028s︠
%coffee
_ = require('underscore')
console.log(_.sortBy([5,3,9,1]))
︡b6e91380-1327-4477-8d42-b249aa881094︡{"stdout":"[ 1, 3, 5, 9 ]\n"}︡{"stderr":"\n"}︡{"done":true}︡
︠18d502a2-79aa-4cd4-a261-76195b76f7b8︠









